SystemOrganization addCategory: #LazyTabPage!

Announcement subclass: #LazyTabPageAnnouncement
	instanceVariableNames: 'page tabs pageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyTabPage'!

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
page
	^ page! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
page: anObject
	page := anObject! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/23/2011 00:23'!
pageIndex
	^ pageIndex! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/23/2011 00:23'!
pageIndex: anObject
	pageIndex := anObject! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
tabs
	^ tabs! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
tabs: anObject
	tabs := anObject! !

LazyTabPageAnnouncement subclass: #LazyTabPageChanged
	instanceVariableNames: 'oldPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyTabPage'!

!LazyTabPageChanged methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
oldPage
	^ oldPage! !

!LazyTabPageChanged methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
oldPage: anObject
	oldPage := anObject! !

LazyTabPageAnnouncement subclass: #LazyTabPageRemoved
	instanceVariableNames: 'newIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyTabPage'!

!LazyTabPageRemoved methodsFor: 'accessing' stamp: 'TudorGirba 7/23/2011 20:20'!
newIndex
	^ newIndex! !

!LazyTabPageRemoved methodsFor: 'accessing' stamp: 'TudorGirba 7/23/2011 20:33'!
newIndex: anObject
	newIndex := anObject! !

BorderedMorph subclass: #LazyTabPage
	instanceVariableNames: 'actualPageMorph labelMorph lazyPageMorphCreation toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyTabPage'!

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 4/4/2011 00:56'!
actualPageMorph
	^ actualPageMorph ifNil: 
		[actualPageMorph := 
			self lazyPageMorphCreation value
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				yourself]! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 17:49'!
actualPageMorph: anObject
	actualPageMorph := anObject! !

!LazyTabPage methodsFor: 'testing' stamp: 'TudorGirba 1/22/2011 22:26'!
isRendered
	^ actualPageMorph notNil! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 17:49'!
labelMorph
	^ labelMorph! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 17:49'!
labelMorph: anObject
	labelMorph := anObject! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 18:11'!
lazyPageMorphCreation
	^ lazyPageMorphCreation! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 18:11'!
lazyPageMorphCreation: anObject
	lazyPageMorphCreation := anObject! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 20:50'!
toolbar
	^ toolbar! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 20:50'!
toolbar: anObject
	toolbar := anObject! !

TestCase subclass: #LazyTabGroupTest
	instanceVariableNames: 'window tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyTabPage'!

!LazyTabGroupTest methodsFor: 'setup - tear down' stamp: ''!
setUp
	tabs := LazyTabGroupMorph new.
	tabs addLazyPage: (PanelMorph new fillStyle: (SolidFillStyle color: Color red)) label: 'one'.
	tabs addLazyPage: (PanelMorph new fillStyle: (SolidFillStyle color: Color yellow)) label: (LabelMorph contents: 'two').
	window := tabs openInWindow.
! !

!LazyTabGroupTest methodsFor: 'setup - tear down' stamp: ''!
tearDown
	window ifNotNil: [window delete]! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testIsRendered
	self assert: tabs pages first isRendered not.
	tabs selectedPageIndex: 1.
	self assert: tabs pages first isRendered.
	self assert: tabs pages second isRendered not! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testPageChangedAnnouncement
	| announcement page |
	announcement := 0.
	tabs announcer
		when: LazyTabPageChanged
		do: [ :ann | 
			announcement := announcement + 1.
			page := ann page ].
	tabs selectedPageIndex: 1.
	self assert: announcement equals: 1.
	self assert: (page isKindOf: LazyTabPage)! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testPageRemovedAnnouncement
	| announcement |
	announcement := 0.
	tabs announcer when: LazyTabPageRemoved do: [ :ann | announcement := announcement + 1 ].
	tabs announcer when: LazyTabPageChanged do: [ :ann | announcement := announcement + 1 ].
	tabs removePage: tabs pages first.
	self assert: announcement equals: 1! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testRemoveAllPages
	tabs removePage: tabs pages first.
	tabs removePage: tabs pages first.
	self assert: tabs pages isEmpty.
	self assert: tabs contentMorph submorphs isEmpty! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testRemovePage
	tabs removePage: tabs pages first.
	self assert: tabs pages size equals: 1! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testSimpleCreation
	self assert: tabs pages size equals: 2! !

TabGroupMorph subclass: #LazyTabGroupMorph
	instanceVariableNames: 'announcer toolbarMorph headerMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyTabPage'!

!LazyTabGroupMorph methodsFor: 'adding' stamp: 'TudorGirba 1/22/2011 21:01'!
addLazyPage: aBlock label: aStringOrMorph
	self addLazyPage: aBlock label: aStringOrMorph toolbar: nil! !

!LazyTabGroupMorph methodsFor: 'adding' stamp: 'TudorGirba 1/22/2011 22:03'!
addLazyPage: aBlock label: aStringOrMorph toolbar: aToolbar
	self addLazyPage: aBlock label: aStringOrMorph toolbar: aToolbar collapsable: false! !

!LazyTabGroupMorph methodsFor: 'adding' stamp: 'TudorGirba 1/22/2011 22:02'!
addLazyPage: aBlock label: aStringOrMorph toolbar: aToolbar collapsable: aBoolean
	| newPage label innerLabel |
	newPage := LazyTabPage new.
	newPage
		lazyPageMorphCreation: aBlock; 
		labelMorph: aStringOrMorph; 
		toolbar: aToolbar.
	innerLabel := aStringOrMorph isMorph
		ifTrue: [aStringOrMorph]
		ifFalse: [(self theme buttonLabelForText: aStringOrMorph)
					font: self font;
					vResizing: #shrinkWrap;
					hResizing: #shrinkWrap].
	label := aBoolean 
			ifTrue: [UITheme builder newRow: { 
				innerLabel .
				UITheme builder
					newCloseControlFor: nil
					action: [self removePage: newPage]
					help: nil}]
			ifFalse: [innerLabel].
	self 
		addPage: newPage
		label: label! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'TudorGirba 7/23/2011 20:14'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'TudorGirba 1/28/2011 01:25'!
headerMorph
	^ headerMorph! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'TudorGirba 1/28/2011 01:25'!
headerMorph: anObject
	headerMorph := anObject! !

!LazyTabGroupMorph methodsFor: 'initialization' stamp: 'TudorGirba 1/28/2011 01:24'!
initialize
	"Initialize the receiver."

	super initialize.
	self removeMorph: self contentMorph;
		removeMorph: self tabSelectorMorph;  
		toolbarMorph: self newToolbarMorph;
		headerMorph: self newHeaderMorph;
		addMorph: self headerMorph;
		addMorph: self contentMorph.

	
"	self
		borderWidth: 0;
		changeTableLayout;
		cellPositioning: #topLeft;
		cellInset: 0 @ -1;
		reverseTableCells: true;
		pageMorphs: OrderedCollection new;
		tabSelectorMorph: self newTabSelectorMorph;
		contentMorph: self newContentMorph;
		addMorph: self tabSelectorMorph;
		addMorph: self contentMorph.
	self tabSelectorMorph addDependent: self"! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 1/28/2011 20:38'!
newHeaderMorph
	^ (self theme 
			newRowIn: self theme
			for: {self tabSelectorMorph . self toolbarMorph}) cellInset: 0; cellPositioning: #bottomCenter; borderWidth: 0! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 1/28/2011 20:36'!
newToolbarMorph
	^ PanelMorph new
		fillStyle: (SolidFillStyle color: Color transparent);
		borderStyle: (BorderStyle width: 0);
		vResizing: #spaceFill;
		hResizing: #shrinkWrap;
		cellPositioning: #center;
		changeTableLayout;
		cellInset: 0;
		yourself ! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 1/22/2011 21:03'!
pageAt: index
	^ (self pages at: index ) actualPageMorph! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 7/23/2011 20:33'!
removePage: aPage
	| removedPageIndex |
	removedPageIndex := self pages indexOf: aPage.
	self announcer suspendAllWhile: [ super removePage: aPage ].
	self announcer announce: 
		(LazyTabPageRemoved new 
			tabs: self; 
			page: aPage; 
			pageIndex: removedPageIndex;
			newIndex: self tabSelectorMorph selectedIndex).
	self pages isEmpty 
		ifTrue: [ self contentMorph removeAllMorphs ]! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 1/23/2011 00:23'!
removePageIndex: anInteger
	self removePage: (self pages at: anInteger)! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'TudorGirba 1/28/2011 00:33'!
toolbarMorph
	^ toolbarMorph! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'TudorGirba 1/28/2011 00:33'!
toolbarMorph: anObject
	toolbarMorph := anObject! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 1/28/2011 20:16'!
updatePageIndex: index
	"Change to the given page index, update the toolbar and send the announcement"

	| p oldPage |
	
	index = 0 ifTrue: [^ self].
	oldPage := self tabSelectorMorph selectedTab.
	p := self pageMorph.
	p isNil
		ifTrue: [self contentMorph addMorph: (self pageAt: index)]
		ifFalse: [self contentMorph replaceSubmorph: p by: (self pageAt: index)].
		
	((self pages at: index) toolbar notNil and: [(self pages at: index) toolbar hasSubmorphs])
		ifTrue: [
			self toolbarMorph hasSubmorphs
				ifFalse: [self toolbarMorph addMorph: (self pages at: index) toolbar ]
				ifTrue: [self toolbarMorph 
								replaceSubmorph: self toolbarMorph submorphs first 
								by: (self pages at: index) toolbar ]]
		ifFalse: [self toolbarMorph removeAllMorphs ].
		
	self headerMorph layoutChanged.
	self pageMorph layoutChanged.
	self adoptPaneColor: (self owner ifNil: [self]) paneColor.
	self announcer announce: (LazyTabPageChanged new tabs: self; page: (self pages at: index); oldPage: oldPage; pageIndex: index)! !
